/* PassControl (C) 1998 by John Wiggings */

#include <Font.h>

#include "PassControl.h"

PassControl::MyFilter::MyFilter()
		: BMessageFilter(B_ANY_DELIVERY, B_ANY_SOURCE, B_KEY_DOWN, NULL)
{
}

filter_result
PassControl::MyFilter::Filter(BMessage *message, BHandler **target)
{
	// message->what == B_KEY_DOWN
	int8 byte;
	message->FindInt8("byte", &byte);
	switch(byte)
	{
		case B_BACKSPACE:
			((PassControl *)((BView *)*target)->Parent())->PopChar(); // gross.. neccessary
			return B_DISPATCH_MESSAGE;
		case B_ENTER:
			return B_SKIP_MESSAGE;
		case B_TAB:
			*target = ((BView *)*target)->Parent(); // send it to the parent bview so you
													// can navigate
			return B_DISPATCH_MESSAGE;
		default:
			((PassControl *)((BView *)*target)->Parent())->PushChar(byte); // ditto
			message->ReplaceInt8("byte", 42); // 42? heh. this is the ascii code for "*". 
												// funny how it really _was_ the answer here
			return B_DISPATCH_MESSAGE;
	}
}

int PassControl::length = 0;
PassControl::PassControl(BRect frame,
						const char *name,
						const char *label, 
						const char *initial_text, 
						BMessage *message)
			: BTextControl(frame, name, label, initial_text, message)

{
	filter = new MyFilter();
	((BTextView *)TextView())->AddFilter(filter);
	
	// font-sensitive code
	// needs for the Width() to be sufficient. this code just makes room 
	// for the label...
	SetDivider(StringWidth(label) + 2.5);
	// ugh. forgive me for magic number usage here
	actual = new char [MAGIC_SIZE]; // YOU define MAGIC_SIZE in PassControl.h
	for(int i=0;i<=MAGIC_SIZE - 1;i++)
		actual[i] = 0; // flush the string
}

PassControl::~PassControl()
{
	if(((BTextView *)TextView())->RemoveFilter(filter))
	{
		delete filter;
	}
	// else leak();
	delete actual;
}

void PassControl::PopChar()
{
	if(length > 0)
		actual[--length] = 0;
}

void PassControl::PushChar(int8 foo)
{
	if(length < (MAGIC_SIZE - 1))
		actual[length++] = foo; // man i hope this converts correctly....
}
